.segment "PESKYTONE_ZP" : zeropage

prev_4003:			.res 1





;------------------------------------------------------------------------------


	.macro PEST_INIT
	
	lda #$01
	sta $4015
	lda #$08
	sta $4001
	
	.endmacro
	
	
;------------------------------------------------------------------------------
	
	
	.macro PEST_DONE
	
	.endmacro
	
	
;------------------------------------------------------------------------------
	
	
	.macro PEST_DETECT_RATE
	
	lda #0
	ldx NTSC_MODE
	bne :+
	lda #1
:
	
	.endmacro
	
	
;------------------------------------------------------------------------------


	.macro PEST_MIX
	
	ldx #(CHANNELS_ALL-1)*CH_STRUCT_SIZE
	
@loop:

	lda PV_CHANNELS+CH_WAVE,x
	bne @output
	
	txa
	sec
	sbc #CH_STRUCT_SIZE
	tax
	bne @loop

@output:

	lda PV_CHANNELS+CH_WAVE,x
	beq :+
	lda #$0f
:
	ora #$30|$80
	sta $4000

	ldy PV_CHANNELS+CH_NOTE_OUT,x
	lda note_table_L,y
	sta $4002

	lda note_table_H,y
	cmp prev_4003
	beq :+
	sta prev_4003
	sta $4003
:
	
	.endmacro
	
	
;------------------------------------------------------------------------------


	.macro PEST_NOTE_TABLE
	
note_table_L:
	.byte $f0,$7e,$12,$ad,$4d,$f2,$9d,$4c
	.byte $00,$b8,$74,$34,$f7,$be,$88,$56
	.byte $26,$f8,$ce,$a5,$7f,$5b,$39,$19
	.byte $fb,$de,$c3,$aa,$92,$7b,$66,$52
	.byte $3f,$2d,$1c,$0c,$fd,$ee,$e1,$d4
	.byte $c8,$bd,$b2,$a8,$9f,$96,$8d,$85
	.byte $7e,$76,$70,$69,$63,$5e,$58,$53
note_table_H:
	.byte $07,$07,$07,$06,$06,$05,$05,$05
	.byte $05,$04,$04,$04,$03,$03,$03,$03
	.byte $03,$02,$02,$02,$02,$02,$02,$02
	.byte $01,$01,$01,$01,$01,$01,$01,$01
	.byte $01,$01,$01,$01,$00,$00,$00,$00
	.byte $00,$00,$00,$00,$00,$00,$00,$00
	.byte $00,$00,$00,$00,$00,$00,$00,$00
	
	.endmacro
