    .importzp       ST
	.include        "c64.inc"
       
CHROUT  = $ffd2          ; CHROUT is the address of the character output routine
GETIN   = $ffe4
CR      = $0d            ; PETSCII code for Carriage Return 
   


.segment "ZEROPAGE"

ptr_zp:	.res 2



.segment "INIT"
.segment "STARTUP"

Start:

	lda #HIRAM|IOEN
	sta $01		
	
	jsr clear_screen	
	
	ldx #<message
	ldy #>message
	jsr print_str

	.include "test_menu.s"
	
	

wait_frame:

@l1:
	bit     VIC_CTRL1
	bpl     @l1
@l2:
	bit     VIC_CTRL1
	bmi     @l2
	
	rts
	
	
	
message:

	.byte "****************************", CR
	.byte "*                          *", CR
	.byte "*  peskytone system test   *", CR
	.byte "*                          *", CR
	.byte "****************************", CR, CR
	.byte " 1 to start music 1", CR
	.byte " 2 to start music 2", CR
	.byte " 3 to stop music", CR
	.byte " 4 to pause music", CR
	.byte " 5 to unpause music", CR
	.byte " a..s to play effects", CR
	.byte " 0 to exit", CR
	.byte 0
	
	
music_1_location:
	.incbin "music_1.bin"
music_2_location:
	.incbin "music_2.bin"
	
	.include "peskytone_struct.s"
	.include "peskytone_c64.s"
	.include "peskytone.s"
	.include "peskytone_sfx.s"