
	jsr pest_init
	
loop_main:

	jsr wait_frame

	jsr pest_update

	jsr GETIN
	beq loop_main
	
	cmp #'a'
	bcc :+
	cmp #'a'+19
	bcs :+
	
	sec
	sbc #'a'
	jsr pest_sound_play
	jmp loop_main

:

	cmp #'1'
	beq play_music_1
	cmp #'2'
	beq play_music_2
	cmp #'3'
	beq stop_music
	cmp #'4'
	beq pause_music
	cmp #'5'
	beq unpause_music
		
	cmp #'0'
	bne loop_main
	
	jsr pest_done
	jsr wait_frame

	rts
	

play_music_1:

	lda #<music_1_location
	ldx #>music_1_location
	jsr pest_music_load
	jsr pest_music_play
	jmp loop_main

play_music_2:

	lda #<music_2_location
	ldx #>music_2_location
	jsr pest_music_load
	jsr pest_music_play
	jmp loop_main
	
stop_music:

	jsr pest_music_stop
	jmp loop_main
	
pause_music:

	lda #1
	jsr pest_music_pause
	jmp loop_main

unpause_music:

	lda #0
	jsr pest_music_pause
	jmp loop_main

	
	
clear_screen:

	lda #$93
	jmp CHROUT

	

print_str:

	stx <ptr_zp+0
	sty <ptr_zp+1
	ldy #0
:
	lda (ptr_zp),y
	beq :+
	jsr CHROUT
	iny
	bne :-
	inc <ptr_zp+1
	jmp :-
:
	rts
